/*
 * @file random.c
 *
 * @author Andy Lindsay
 *
 * @version 1.1.8
 *
 * @copyright Copyright (C) Parallax, Inc. 2018.  See end of file for 
 * terms of use (MIT License).
 *
 * @brief random function source, see simpletools.h for documentation.
 *
 * @detail Please submit bug reports, suggestions, and improvements to
 * this code to editor@parallax.com.
 */

static int seeded = 0;

#include "simpletools.h" 


int random(int limitLow, int limitHigh)
{ 
  if(!seeded) 
  {
    srand(INA + CNT);
    seeded = 1;
  }    
    
  if(limitLow > limitHigh)
  {
    int temp = limitLow;
    limitLow = limitHigh;
    limitHigh = temp;
  }    
  return (limitLow + (rand() % ((limitHigh + 1) - limitLow)) );
}



  
/**
 * TERMS OF USE: MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
                            